package desim

// GENERATED CODE, DO NOT EDIT
// This code was generated by a tool.
//
// 	github.com/aybabtme/datagen
//
// The command that generated this was:
//
//	datagen q --key *reservation

// Implementation adapted from github.com/eapache/queue:
//    The MIT License (MIT)
//    Copyright (c) 2014 Evan Huus

var nilreservation *reservation

// reservationQueue represents a single instance of the queue data structure.
type reservationQueue struct {
	buf               []*reservation
	head, tail, count int
	minlen            int
}

// newReservationQueue constructs and returns a new reservationQueue with an initial capacity.
func newReservationQueue(capacity int) *reservationQueue {
	// min capacity of 16
	if capacity < 16 {
		capacity = 16
	}
	return &reservationQueue{buf: make([]*reservation, capacity), minlen: capacity}
}

// Len returns the number of elements currently stored in the queue.
func (q *reservationQueue) Len() int {
	return q.count
}

// Push puts an element on the end of the queue.
func (q *reservationQueue) Push(elem *reservation) {
	if q.count == len(q.buf) {
		q.resize()
	}

	q.buf[q.tail] = elem
	q.tail = (q.tail + 1) % len(q.buf)
	q.count++
}

// Peek returns the element at the head of the queue. This call panics
// if the queue is empty.
func (q *reservationQueue) Peek() *reservation {
	if q.Len() <= 0 {
		panic("queue: empty queue")
	}
	return q.buf[q.head]
}

// Get returns the element at index i in the queue. If the index is
// invalid, the call will panic.
func (q *reservationQueue) Get(i int) *reservation {
	if i >= q.Len() || i < 0 {
		panic("queue: index out of range")
	}
	modi := (q.head + i) % len(q.buf)
	return q.buf[modi]
}

// Pop removes the element from the front of the queue.
// This call panics if the queue is empty.
func (q *reservationQueue) Pop() *reservation {
	if q.Len() <= 0 {
		panic("queue: empty queue")
	}
	v := q.buf[q.head]
	// set to nil to avoid keeping reference to objects
	// that would otherwise be garbage collected
	q.buf[q.head] = nilreservation
	q.head = (q.head + 1) % len(q.buf)
	q.count--
	if len(q.buf) > q.minlen && q.count*4 <= len(q.buf) {
		q.resize()
	}
	return v
}

func (q *reservationQueue) resize() {
	newBuf := make([]*reservation, q.count*2)

	if q.tail > q.head {
		copy(newBuf, q.buf[q.head:q.tail])
	} else {
		copy(newBuf, q.buf[q.head:len(q.buf)])
		copy(newBuf[len(q.buf)-q.head:], q.buf[:q.tail])
	}

	q.head = 0
	q.tail = q.count
	q.buf = newBuf
}
